/* BDSIM code.    Version 1.0
   Author: Grahame A. Blair, Royal Holloway, Univ. of London.
   Last modified 24.7.2002
   Copyright (c) 2002 by G.A.Blair.  ALL RIGHTS RESERVED. 
*/

//==========================================================
//==========================================================

#include "BDSExecOptions.hh"
#include "BDSGlobalConstants.hh" 
#include "BDSDebug.hh"
#include "BDSRunAction.hh"
#include "BDSRunManager.hh"
#include "BDSDump.hh"
#include "BDSBeamline.hh"

#include "G4Run.hh"
#include "G4StateManager.hh"
#include "G4UImanager.hh"
#include "G4VVisManager.hh"
#include "G4ios.hh"

#include "BDSAcceleratorComponent.hh"
#include <list>
#include <fstream>
#include <string>

#include "BDSTrackingFIFO.hh"

#if defined(__unix__) || defined(__linux__) || defined(__APPLE__)
#include <unistd.h> // for sleep, will not work on windows?
#endif


//==========================================================

BDSRunAction::BDSRunAction()
{
  nptwiss = BDSExecOptions::Instance()->GetNPTwiss();
}

//==========================================================

BDSRunAction::~BDSRunAction()
{}

//==========================================================

void BDSRunAction::BeginOfRunAction(const G4Run* aRun)
{
  G4cout << "### Run " << aRun->GetRunID() << " start." << G4endl;

  //  if (G4VVisManager::GetConcreteInstance())
  //    {
      //      G4UImanager* UI = G4UImanager::GetUIpointer(); 
      //  UI->ApplyCommand("/vis/scene/notifyHandlers");
  //    } 


}

//==========================================================

void BDSRunAction::EndOfRunAction(const G4Run* aRun)
{
  //Do the fifo at the end of the run.
  BDSTrackingFIFO* fifo = new BDSTrackingFIFO();
  fifo->doFifo();
  G4cout << "### Run " << aRun->GetRunID() << " end." << G4endl;
}
//==========================================================
